diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc
--- ns-3.44/src/wifi/test/wifi-phy-ofdma-test.cc	2025-03-09 16:55:49.811372800 -0700
+++ ns-3.45/src/wifi/test/wifi-phy-ofdma-test.cc	2025-06-01 20:34:45.641702400 -0700
@@ -4997,7 +5376,7 @@
     NS_TEST_ASSERT_MSG_EQ(
         m_countRxFailureFromSta1,
         expectedFailures,
-        "The number of unsuccessfuly received packets from STA 1 is not correct!");
+        "The number of unsuccessfully received packets from STA 1 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesFromSta1,
                           expectedBytes,
                           "The number of bytes received from STA 1 is not correct!");
@@ -5014,7 +5393,7 @@
     NS_TEST_ASSERT_MSG_EQ(
         m_countRxFailureFromSta2,
         expectedFailures,
-        "The number of unsuccessfuly received packets from STA 2 is not correct!");
+        "The number of unsuccessfully received packets from STA 2 is not correct!");
     NS_TEST_ASSERT_MSG_EQ(m_countRxBytesFromSta2,
                           expectedBytes,
                           "The number of bytes received from STA 2 is not correct!");
@@ -5035,7 +5414,8 @@
 }
 
 void
-TestPhyPaddingExclusion::CheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState)
+TestPhyPaddingExclusion::CheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy,
+                                       WifiPhyState expectedState)
 {
     // This is needed to make sure PHY state will be checked as the last event if a state change
     // occurred at the exact same time as the check
@@ -5043,7 +5423,8 @@
 }
 
 void
-TestPhyPaddingExclusion::DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy> phy, WifiPhyState expectedState)
+TestPhyPaddingExclusion::DoCheckPhyState(Ptr<OfdmaSpectrumWifiPhy<HePhy>> phy,
+                                         WifiPhyState expectedState)
 {
     WifiPhyState currentState = phy->GetState()->GetState();
     NS_LOG_FUNCTION(this << currentState);
@@ -5089,7 +5470,7 @@
         PointerValue(CreateObjectWithAttributes<Txop>("AcIndex", StringValue("AC_BE_NQOS"))));
     apMac->SetAttribute("BeaconGeneration", BooleanValue(false));
     apDev->SetMac(apMac);
-    m_phyAp = CreateObject<OfdmaSpectrumWifiPhy>(0);
+    m_phyAp = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(0);
     Ptr<HeConfiguration> heConfiguration = CreateObject<HeConfiguration>();
     apDev->SetHeConfiguration(heConfiguration);
     Ptr<InterferenceHelper> apInterferenceHelper = CreateObject<InterferenceHelper>();
@@ -5122,7 +5503,7 @@
 
     Ptr<Node> sta1Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta1Dev = CreateObject<WifiNetDevice>();
-    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy>(1);
+    m_phySta1 = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(1);
     Ptr<InterferenceHelper> sta1InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta1->SetInterferenceHelper(sta1InterferenceHelper);
     Ptr<ErrorRateModel> sta1ErrorModel = CreateObject<NistErrorRateModel>();
@@ -5143,7 +5524,7 @@
 
     Ptr<Node> sta2Node = CreateObject<Node>();
     Ptr<WifiNetDevice> sta2Dev = CreateObject<WifiNetDevice>();
-    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy>(2);
+    m_phySta2 = CreateObject<OfdmaSpectrumWifiPhy<HePhy>>(2);
     Ptr<InterferenceHelper> sta2InterferenceHelper = CreateObject<InterferenceHelper>();
     m_phySta2->SetInterferenceHelper(sta2InterferenceHelper);
     Ptr<ErrorRateModel> sta2ErrorModel = CreateObject<NistErrorRateModel>();
@@ -5198,10 +5579,10 @@
                             false,
                             false,
                             true};
-    trigVector.SetRu(HeRu::RuSpec(HeRu::RU_106_TONE, 1, false), 1);
+    trigVector.SetRu(HeRu::RuSpec(RuType::RU_106_TONE, 1, false), 1);
     trigVector.SetMode(HePhy::GetHeMcs7(), 1);
     trigVector.SetNss(1, 1);
-    trigVector.SetRu(HeRu::RuSpec(HeRu::RU_106_TONE, 2, false), 2);
+    trigVector.SetRu(HeRu::RuSpec(RuType::RU_106_TONE, 2, false), 2);
     trigVector.SetMode(HePhy::GetHeMcs7(), 2);
     trigVector.SetNss(1, 2);
     uint16_t length;
@@ -5223,14 +5604,14 @@
 
     // STA1 and STA2 send MU UL PPDUs addressed to AP:
     Simulator::Schedule(Seconds(1),
-                        &TestPhyPaddingExclusion::SendHeTbPpdu,
+                        &TestPhyPaddingExclusion::SendTbPpdu,
                         this,
                         1,
                         1,
                         1000,
                         ppduWithPaddingDuration);
     Simulator::Schedule(Seconds(1),
-                        &TestPhyPaddingExclusion::SendHeTbPpdu,
+                        &TestPhyPaddingExclusion::SendTbPpdu,
                         this,
                         2,
                         2,
@@ -5266,14 +5647,14 @@
 
     // STA1 and STA2 send MU UL PPDUs addressed to AP:
     Simulator::Schedule(Seconds(2),
-                        &TestPhyPaddingExclusion::SendHeTbPpdu,
+                        &TestPhyPaddingExclusion::SendTbPpdu,
                         this,
                         1,
                         1,
                         1000,
                         ppduWithPaddingDuration);
     Simulator::Schedule(Seconds(2),
-                        &TestPhyPaddingExclusion::SendHeTbPpdu,
+                        &TestPhyPaddingExclusion::SendTbPpdu,
                         this,
                         2,
                         2,
@@ -5461,14 +5842,14 @@
     muBar.SetApTxPower(static_cast<int8_t>(m_txPowerAp));
     muBar.SetUlSpatialReuse(60500);
 
-    HeRu::RuType ru = (staIds.size() == 1) ? HeRu::RU_242_TONE : HeRu::RU_106_TONE;
+    RuType ru = (staIds.size() == 1) ? RuType::RU_242_TONE : RuType::RU_106_TONE;
     std::size_t index = 1;
     int8_t ulTargetRssi = -40; // will be overwritten
     for (const auto& staId : staIds)
     {
         CtrlTriggerUserInfoField& ui = muBar.AddUserInfoField();
         ui.SetAid12(staId);
-        ui.SetRuAllocation({ru, index, true});
+        ui.SetRuAllocation(HeRu::RuSpec{ru, index, true});
         ui.SetUlFecCodingType(true);
         ui.SetUlMcs(7);
         ui.SetUlDcm(false);
@@ -5646,7 +6027,7 @@
                 TimeValue(MicroSeconds(1024 * 600)));
     m_apDev = DynamicCast<WifiNetDevice>(wifi.Install(spectrumPhy, mac, apNode).Get(0));
     NS_ASSERT(m_apDev);
-    m_apDev->GetHeConfiguration()->SetAttribute("BssColor", UintegerValue(m_bssColor));
+    m_apDev->GetHeConfiguration()->m_bssColor = m_bssColor;
     m_phyAp = DynamicCast<SpectrumWifiPhy>(m_apDev->GetPhy());
     NS_ASSERT(m_phyAp);
     // ReceiveOkCallback of AP will be set to corresponding test's method once BA sessions have been
@@ -5853,11 +6234,13 @@
 WifiPhyOfdmaTestSuite::WifiPhyOfdmaTestSuite()
     : TestSuite("wifi-phy-ofdma", Type::UNIT)
 {
-    AddTestCase(new TestDlOfdmaPhyTransmission, TestCase::Duration::QUICK);
+    AddTestCase(new TestDlOfdmaPhyTransmission<HePhy>(), TestCase::Duration::QUICK);
+    AddTestCase(new TestDlOfdmaPhyTransmission<EhtPhy>(), TestCase::Duration::QUICK);
     AddTestCase(new TestDlOfdmaPhyPuncturing, TestCase::Duration::QUICK);
     AddTestCase(new TestUlOfdmaPpduUid, TestCase::Duration::QUICK);
     AddTestCase(new TestMultipleHeTbPreambles, TestCase::Duration::QUICK);
-    AddTestCase(new TestUlOfdmaPhyTransmission, TestCase::Duration::QUICK);
+    AddTestCase(new TestUlOfdmaPhyTransmission<HePhy>(), TestCase::Duration::QUICK);
+    AddTestCase(new TestUlOfdmaPhyTransmission<EhtPhy>(), TestCase::Duration::QUICK);
     AddTestCase(new TestPhyPaddingExclusion, TestCase::Duration::QUICK);
     AddTestCase(new TestUlOfdmaPowerControl, TestCase::Duration::QUICK);
 }
